#pragma once

#include"SmartSegPatch.h"


using namespace Segmentation;

class SegTreeNode
{
public:
	SegPatch *segmt;
	SegTreeNode *parnt;
	SegTreeNode *child;
	SegTreeNode *siblg;

	int nchild;
	int level;

	float value0, value1;
	float value_acc, weight_acc;
	float value_up, weight_up;

	float *bp_msg_in_sum;				// sum of all received message
	//float **msg_in;					// message received from each neighbor
	std::map<int, float*>bp_msg_in;
	float *bp_data_term;				// data term energy

	SegTreeNode() 
	{
		segmt = NULL; 
		parnt = NULL;
		child = NULL; 
		siblg = NULL;
		nchild = 0;
	}

	~SegTreeNode() 
	{
		segmt = NULL;
		parnt = NULL;
		delete child;
		child = NULL;
		delete siblg; 
		siblg = NULL;
	}

	void AddChild(SegTreeNode *node)
	{
		if ( child != NULL )
		{
			node->siblg = child;
			child = node;
		}
		node->parnt = this;
		child = node;
		nchild ++;
	}

	void SetMsgTo(float value);
};

class SegTree
{
public:
	static const int LABEL_NUM = 100;
	static const int NEIGHBOR_NUM = 10;
	SegTree(void);
	~SegTree(void);

	void BuildTreeFromSeg(Mat *segMap, vector<SegPatch*>* segList_all, float **value, int N);
		
	void BPL1(float *salFused, float sal_max, float sal_min, int N_SCALES, float *lambda, float *beta);
	void BPL1Init(float sal_max, float sal_min, int N_SCALES, float *lambda, float *beta);
	void BPL1Clear();


	void BPL2T(float *salFused, float sal_max, float sal_min, int N_SCALES, float *lambda, float *beta);
	void BPL2TInit(float sal_max, float sal_min, int N_SCALES, float *lambda, float *beta);
	void BPL2TUpdate_p2q(float *msg_to_q, float *msg_in_sum_q, float *msg_from_q, float *msg_in_sum_p, float *data_term_p, float lambdai);
	void BPL2TClear();

	SegTreeNode *root, *end;
	int n_nodes;

private:

	int msg_pool_num;
	float *msg_pool;

	int node_pool_num;
	SegTreeNode *node_pool;
	
};

