#include <cmath>
#include <algorithm>
#include <fstream>
#include <iostream>
#include <sstream>

//#define CHRONO
//#include "geom.h"
#include "fast_lbf.h"

#include "utils.h"


using namespace cv;


namespace BFilter
{
	typedef Array_2D<double> image_type;

	void bilateral3u( Mat &img, Mat &outimg, double sigma_s, double sigma_r )
	{
		bilateralu(img, outimg, sigma_s, sigma_r);
		return;

		double R,G,B;
		int width = img.cols;
		int height = img.rows;
		image_type image_r(width,height), filtered_image_r(width,height);
		image_type image_g(width,height), filtered_image_g(width,height);
		image_type image_b(width,height), filtered_image_b(width,height);
				
		uchar *D = img.data;
		Loop_Image(x,y,width,height)
		{
			image_r(x,y) = D[(y*width+x)*3]/255.0;//img.at<uchar>(x,y,0)/255.0;
			image_g(x,y) = D[(y*width+x)*3+1]/255.0;//img.at<uchar>(x,y,0)/255.0;
			image_b(x,y) = D[(y*width+x)*3+2]/255.0;//img.at<uchar>(x,y,0)/255.0;
		}
		
		Image_filter::fast_LBF(image_r,image_r,
			sigma_s,sigma_r,true,
			&filtered_image_r,&filtered_image_r);
		Image_filter::fast_LBF(image_g,image_g,
			sigma_s,sigma_r,true,
			&filtered_image_g,&filtered_image_g);
		Image_filter::fast_LBF(image_b,image_b,
			sigma_s,sigma_r,true,
			&filtered_image_b,&filtered_image_b);
		
		//cvZero(outimg);
		outimg.create(height, width, CV_8UC3);
		D = outimg.data;
		Loop_Image(x,y,width,height)
		{
			//outimg.at<uchar>(y,x,0) = int(filtered_image_r(x,y)*255.0+0.5);
			//outimg.at<uchar>(y,x,1) = int(filtered_image_g(x,y)*255.0+0.5);
			//outimg.at<uchar>(y,x,2) = int(filtered_image_b(x,y)*255.0+0.5);
			D[(y*width+x)*3] = int(filtered_image_r(x,y)*255.0+0.5);
			D[(y*width+x)*3+1] = int(filtered_image_g(x,y)*255.0+0.5);
			D[(y*width+x)*3+2] = int(filtered_image_b(x,y)*255.0+0.5);
		} 
		//imwrite("test.png",outimg);
	}





	void bilateralu( cv::Mat &img, cv::Mat &outimg, double sigma_s, double sigma_r, cv::Mat &edge /*= cv::Mat()*/ )
	{
		double R,G,B;
		int width = img.cols;
		int height = img.rows;
		int chs = img.channels();

		if ( chs == 1 )
		{
			image_type image_r(width,height), filtered_image_r(width,height);
			image_type *edge_;
			
			uchar *D = img.data;
			Loop_Image(x,y,width,height)
				image_r(x,y) = D[(y*width+x)]/255.0;//img.at<uchar>(x,y,0)/255.0;

			if (edge.data)
			{
				edge_ = new image_type(width, height);
				D = edge.data;
				Loop_Image(x,y,width,height)
					(*edge_)(x,y) = D[(y*width+x)]/255.0;
			}
			else
			{
				edge_ = &image_r;
			}
			Image_filter::fast_LBF(image_r,*edge_,sigma_s,sigma_r,true,&filtered_image_r,&filtered_image_r);
			
			outimg.create(height, width, CV_8UC1);
			D = outimg.data;
			Loop_Image(x,y,width,height)
				D[(y*width+x)] = int(filtered_image_r(x,y)*255.0+0.5);
					
			if (edge.data) delete edge_;
		}
		else if ( chs == 3 )
		{
			image_type image_r(width,height), filtered_image_r(width,height);
			image_type image_g(width,height), filtered_image_g(width,height);
			image_type image_b(width,height), filtered_image_b(width,height);
			image_type *edge_r, *edge_g, *edge_b;

			uchar *D = img.data;
			Loop_Image(x,y,width,height)
			{
				image_r(x,y) = D[(y*width+x)*3]/255.0;//img.at<uchar>(x,y,0)/255.0;
				image_g(x,y) = D[(y*width+x)*3+1]/255.0;//img.at<uchar>(x,y,0)/255.0;
				image_b(x,y) = D[(y*width+x)*3+2]/255.0;//img.at<uchar>(x,y,0)/255.0;
			}

			if (edge.data)
			{
				if (edge.channels()==1)
				{	
					edge_r = new image_type(width,height);
					D = edge.data;
					Loop_Image(x,y,width,height)
						(*edge_r)(x,y) = D[(y*width+x)]/255.0;
					edge_g = edge_r;
					edge_b = edge_r;
				}
				else
				{
					edge_r = new image_type(width,height);
					edge_g = new image_type(width,height);
					edge_b = new image_type(width,height);
					D = edge.data;
					Loop_Image(x,y,width,height)
					{
						(*edge_r)(x,y) = D[(y*width+x)*3]/255.0;
						(*edge_g)(x,y) = D[(y*width+x)*3+1]/255.0;
						(*edge_b)(x,y) = D[(y*width+x)*3+2]/255.0;
					}
				}
			}
			else
			{
				edge_r = &image_r;
				edge_g = &image_g;
				edge_b = &image_b;
			}

			Image_filter::fast_LBF(image_r,*edge_r,sigma_s,sigma_r,true,&filtered_image_r,&filtered_image_r);
			Image_filter::fast_LBF(image_g,*edge_g,sigma_s,sigma_r,true,&filtered_image_g,&filtered_image_g);
			Image_filter::fast_LBF(image_b,*edge_b,sigma_s,sigma_r,true,&filtered_image_b,&filtered_image_b);
						
			outimg.create(height, width, CV_8UC3);
			D = outimg.data;
			Loop_Image(x,y,width,height)
			{
				D[(y*width+x)*3] = int(filtered_image_r(x,y)*255.0+0.5);
				D[(y*width+x)*3+1] = int(filtered_image_g(x,y)*255.0+0.5);
				D[(y*width+x)*3+2] = int(filtered_image_b(x,y)*255.0+0.5);
			} 

			if (edge.data)
			{
				if (edge.channels()==1) delete edge_r;
				else {delete edge_r; delete edge_g; delete edge_b;}
			}
		}
		else
		{
			img.copyTo(outimg);
		}

	}

}