
#include "SegUtil.h"


void CreateSegList(ZIntImage& m_segImg, std::vector<SegPatch*>& m_segList)
{
	int i,j;
	int iMaxSegIndex = 0;
	int m_iWidth = m_segImg.GetWidth();
	int m_iHeight = m_segImg.GetHeight();

	if(m_segList.size()>0){
		for(i=0;i<m_segList.size();i++)
			delete m_segList[i];
		m_segList.clear();
	}


	for(j=0;j<m_iHeight;j++)
		for(i=0;i<m_iWidth;i++){
			iMaxSegIndex = max(iMaxSegIndex,m_segImg.at(i,j));
		}

	m_segList.resize(iMaxSegIndex+1);
	for(i=0;i<=iMaxSegIndex;i++){
		m_segList[i] = new SegPatch;
		m_segList[i]->m_iLabel = i;
	}

	for(j=0;j<m_iHeight;j++)
		for(i=0;i<m_iWidth;i++){
			m_segList[m_segImg.at(i,j)]->Add(i,j);			
		}

		
	//CheckSegment(100,100);
	//update segmap
	for(i=0;i<m_segList.size();i++){
		std::vector<CPoint>::iterator iter = m_segList[i]->m_ptlist.begin();		
		for(;iter!=m_segList[i]->m_ptlist.end();iter++){			
			m_segImg.at((*iter).x,(*iter).y) = i;
		}
	}
		

	for(i=0;i<m_segList.size();i++)
		m_segList[i]->CalCenter();

		
}
