// Segmentation.cpp : Defines the entry point for the DLL application.
//
#include <algorithm>
#include "Segmentation.h"

#define	Loop_Image(x,y,width,height) for(int y=0; y<height; y++) for(int x=0; x<width; x++)
//#define SEGMENTATION_PROMPT


///////////////////////////////////////////////////////////////////////////////////////////////////
// timing
///////////////////////////////////////////////////////////////////////////////////////////////////
clock_t cCheckTime_ = 0;
clock_t cummulateTime_ = 0;
clock_t cummulateCounter_ = 0;

void CCLEAR_(){
	cummulateTime_ = 0;
	cummulateCounter_ = 0;
}

void CSTART_(){
	cCheckTime_ = clock();
}

void CEND_(){
	clock_t newTime_ = clock();
	cummulateTime_ += newTime_ - cCheckTime_;
	cCheckTime_ = newTime_;

	cummulateCounter_++;
}

void CSUMMARY_(){
	printf("cummulate time: %d ms\n",cummulateTime_);
	//printf("cummulate counter: %d\n",cummulateCounter);
}


namespace Segmentation
{	
	// input -- uchar (BGR)
	// output -- int (1)
	// outputImg -- uchar (BGR)
	void SegmentImage(Mat* input, Mat* output, Mat *outputImg, int *minReg, int *scales, int iter, int sigma_s, float sigma_r)
	{
		srand(20130413);
		
		msImageProcessor imgProcr;
		SpeedUpLevel spdLvl = MED_SPEEDUP;
		int w = input->cols;
		int h = input->rows;
		int c = input->channels();
		imageType type = GRAYSCALE;
		//Mat tmpSeg(h, w, CV_8U);
		//std::vector<SegPatch*> segList;

		//for debug
		Mat testImg(h, w, 3);

		if(3 == c)
			type = COLOR;

		// convert to uchar image which fulfills the needs of meanshift api
		uchar* img = new uchar[w*h*c];
		int *iD;

		if (type==GRAYSCALE)
		{
			memcpy(img, input->data, w*h);
		}
		else
		{
			// opencv BGR to RGB
			uchar *uPtr = input->data;
			for (int y=0; y<h; y++ )
			{
				for (int x=0; x<w; x++)
				{
					img[ (y*w+x)*3 + 0 ] = uPtr[ (y*w+x)*3 + 2];
					img[ (y*w+x)*3 + 1 ] = uPtr[ (y*w+x)*3 + 1];
					img[ (y*w+x)*3 + 2 ] = uPtr[ (y*w+x)*3 + 0];
				}
			}
		}

#ifdef SEGMENTATION_PROMPT
		printf("DefineImage\n");
#endif
		imgProcr.DefineImage(img, type, h, w);

		//printf("Filter\n");
		//imgProcr.Filter(sigma_s, sigma_r, spdLvl);

#ifdef SEGMENTATION_PROMPT
		printf("FuseRegions\n");
#endif
//		CCLEAR_();
		for (int ii=0; ii<iter; ii++)
		{
//			CSTART_();
			imgProcr.FuseRegions(sigma_r, minReg[ii], scales[ii], outputImg[ii]);
			memcpy(output[ii].ptr<int>(), imgProcr.labels, w*h*sizeof(int));
//			CEND_();
		}
//		CSUMMARY_();

#ifdef SEGMENTATION_PROMPT
		printf("Done\n");
#endif

		delete[] img;
	}
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


}